diff -NurpP --minimal linux-2.6.18/Makefile linux-2.6.18-vs2.1.1-rc37/Makefile
--- linux-2.6.18/Makefile	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/Makefile	2006-10-07 15:29:07 +0200
@@ -1,7 +1,7 @@
 VERSION = 2
 PATCHLEVEL = 6
 SUBLEVEL = 18
-EXTRAVERSION =
+EXTRAVERSION = -vs2.1.1-rc37
 NAME=Avast! A bilge rat!
 
 # *DOCUMENTATION*
diff -NurpP --minimal linux-2.6.18/arch/alpha/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/alpha/Kconfig
--- linux-2.6.18/arch/alpha/Kconfig	2006-06-18 04:51:38 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/alpha/Kconfig	2006-09-20 17:01:44 +0200
@@ -632,6 +632,8 @@ source "arch/alpha/oprofile/Kconfig"
 
 source "arch/alpha/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/alpha/kernel/asm-offsets.c linux-2.6.18-vs2.1.1-rc37/arch/alpha/kernel/asm-offsets.c
--- linux-2.6.18/arch/alpha/kernel/asm-offsets.c	2006-02-15 13:54:10 +0100
+++ linux-2.6.18-vs2.1.1-rc37/arch/alpha/kernel/asm-offsets.c	2006-09-25 15:40:02 +0200
@@ -36,6 +36,7 @@ void foo(void)
 	DEFINE(PT_PTRACED, PT_PTRACED);
 	DEFINE(CLONE_VM, CLONE_VM);
 	DEFINE(CLONE_UNTRACED, CLONE_UNTRACED);
+	DEFINE(CLONE_KTHREAD, CLONE_KTHREAD);
 	DEFINE(SIGCHLD, SIGCHLD);
 	BLANK();
 
diff -NurpP --minimal linux-2.6.18/arch/alpha/kernel/entry.S linux-2.6.18-vs2.1.1-rc37/arch/alpha/kernel/entry.S
--- linux-2.6.18/arch/alpha/kernel/entry.S	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/alpha/kernel/entry.S	2006-09-25 15:40:02 +0200
@@ -644,7 +644,7 @@ kernel_thread:
 	stq	$2, 152($sp)		/* HAE */
 
 	/* Shuffle FLAGS to the front; add CLONE_VM.  */
-	ldi	$1, CLONE_VM|CLONE_UNTRACED
+	ldi	$1, CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD;
 	or	$18, $1, $16
 	bsr	$26, sys_clone
 
@@ -873,24 +873,15 @@ sys_getxgid:
 	.globl	sys_getxpid
 	.ent	sys_getxpid
 sys_getxpid:
+	lda	$sp, -16($sp)
+	stq	$26, 0($sp)
 	.prologue 0
-	ldq	$2, TI_TASK($8)
 
-	/* See linux/kernel/timer.c sys_getppid for discussion
-	   about this loop.  */
-	ldq	$3, TASK_GROUP_LEADER($2)
-	ldq	$4, TASK_REAL_PARENT($3)
-	ldl	$0, TASK_TGID($2)
-1:	ldl	$1, TASK_TGID($4)
-#ifdef CONFIG_SMP
-	mov	$4, $5
-	mb
-	ldq	$3, TASK_GROUP_LEADER($2)
-	ldq	$4, TASK_REAL_PARENT($3)
-	cmpeq	$4, $5, $5
-	beq	$5, 1b
-#endif
-	stq	$1, 80($sp)
+	lda	$16, 96($sp)
+	jsr	$26, do_getxpid
+	ldq	$26, 0($sp)
+
+	lda	$sp, 16($sp)
 	ret
 .end sys_getxpid
 
diff -NurpP --minimal linux-2.6.18/arch/alpha/kernel/osf_sys.c linux-2.6.18-vs2.1.1-rc37/arch/alpha/kernel/osf_sys.c
--- linux-2.6.18/arch/alpha/kernel/osf_sys.c	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/alpha/kernel/osf_sys.c	2006-09-25 15:40:02 +0200
@@ -38,6 +38,7 @@
 #include <linux/uio.h>
 #include <linux/vfs.h>
 #include <linux/rcupdate.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/fpu.h>
 #include <asm/io.h>
@@ -399,18 +400,20 @@ asmlinkage int
 osf_utsname(char __user *name)
 {
 	int error;
+	struct new_utsname *ptr;
 
 	down_read(&uts_sem);
+	ptr = vx_new_utsname();
 	error = -EFAULT;
-	if (copy_to_user(name + 0, system_utsname.sysname, 32))
+	if (copy_to_user(name + 0, ptr->sysname, 32))
 		goto out;
-	if (copy_to_user(name + 32, system_utsname.nodename, 32))
+	if (copy_to_user(name + 32, ptr->nodename, 32))
 		goto out;
-	if (copy_to_user(name + 64, system_utsname.release, 32))
+	if (copy_to_user(name + 64, ptr->release, 32))
 		goto out;
-	if (copy_to_user(name + 96, system_utsname.version, 32))
+	if (copy_to_user(name + 96, ptr->version, 32))
 		goto out;
-	if (copy_to_user(name + 128, system_utsname.machine, 32))
+	if (copy_to_user(name + 128, ptr->machine, 32))
 		goto out;
 
 	error = 0;
@@ -439,6 +442,7 @@ osf_getdomainname(char __user *name, int
 {
 	unsigned len;
 	int i;
+	char *domainname;
 
 	if (!access_ok(VERIFY_WRITE, name, namelen))
 		return -EFAULT;
@@ -448,9 +452,10 @@ osf_getdomainname(char __user *name, int
 		len = 32;
 
 	down_read(&uts_sem);
+	domainname = vx_new_uts(domainname);
 	for (i = 0; i < len; ++i) {
-		__put_user(system_utsname.domainname[i], name + i);
-		if (system_utsname.domainname[i] == '\0')
+		__put_user(domainname[i], name + i);
+		if (domainname[i] == '\0')
 			break;
 	}
 	up_read(&uts_sem);
@@ -607,30 +612,30 @@ osf_sigstack(struct sigstack __user *uss
 asmlinkage long
 osf_sysinfo(int command, char __user *buf, long count)
 {
-	static char * sysinfo_table[] = {
-		system_utsname.sysname,
-		system_utsname.nodename,
-		system_utsname.release,
-		system_utsname.version,
-		system_utsname.machine,
-		"alpha",	/* instruction set architecture */
-		"dummy",	/* hardware serial number */
-		"dummy",	/* hardware manufacturer */
-		"dummy",	/* secure RPC domain */
-	};
 	unsigned long offset;
 	char *res;
 	long len, err = -EINVAL;
 
 	offset = command-1;
-	if (offset >= ARRAY_SIZE(sysinfo_table)) {
+	if (offset >= 9) {
 		/* Digital UNIX has a few unpublished interfaces here */
 		printk("sysinfo(%d)", command);
 		goto out;
 	}
 
 	down_read(&uts_sem);
-	res = sysinfo_table[offset];
+	switch (offset)
+	{
+	case 0:	res = vx_new_uts(sysname);  break;
+	case 1:	res = vx_new_uts(nodename); break;
+	case 2:	res = vx_new_uts(release);  break;
+	case 3:	res = vx_new_uts(version);  break;
+	case 4: res = vx_new_uts(machine);  break;
+	case 5:	res = "alpha";              break;
+	default:
+		res = "dummy";
+		break;
+	}
 	len = strlen(res)+1;
 	if (len > count)
 		len = count;
@@ -881,7 +886,7 @@ osf_gettimeofday(struct timeval32 __user
 {
 	if (tv) {
 		struct timeval ktv;
-		do_gettimeofday(&ktv);
+		vx_gettimeofday(&ktv);
 		if (put_tv32(tv, &ktv))
 			return -EFAULT;
 	}
diff -NurpP --minimal linux-2.6.18/arch/alpha/kernel/ptrace.c linux-2.6.18-vs2.1.1-rc37/arch/alpha/kernel/ptrace.c
--- linux-2.6.18/arch/alpha/kernel/ptrace.c	2006-04-09 13:49:39 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/alpha/kernel/ptrace.c	2006-10-06 23:10:42 +0200
@@ -283,6 +283,11 @@ do_sys_ptrace(long request, long pid, lo
 		goto out_notsk;
 	}
 
+	if (!vx_check(vx_task_xid(child), VX_WATCH_P|VX_IDENT)) {
+		ret = -EPERM;
+		goto out;
+	}
+
 	if (request == PTRACE_ATTACH) {
 		ret = ptrace_attach(child);
 		goto out;
diff -NurpP --minimal linux-2.6.18/arch/alpha/kernel/systbls.S linux-2.6.18-vs2.1.1-rc37/arch/alpha/kernel/systbls.S
--- linux-2.6.18/arch/alpha/kernel/systbls.S	2005-08-29 22:24:49 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/alpha/kernel/systbls.S	2006-09-20 17:01:44 +0200
@@ -447,7 +447,7 @@ sys_call_table:
 	.quad sys_stat64			/* 425 */
 	.quad sys_lstat64
 	.quad sys_fstat64
-	.quad sys_ni_syscall			/* sys_vserver */
+	.quad sys_vserver			/* sys_vserver */
 	.quad sys_ni_syscall			/* sys_mbind */
 	.quad sys_ni_syscall			/* sys_get_mempolicy */
 	.quad sys_ni_syscall			/* sys_set_mempolicy */
diff -NurpP --minimal linux-2.6.18/arch/alpha/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/alpha/kernel/traps.c
--- linux-2.6.18/arch/alpha/kernel/traps.c	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/alpha/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -182,7 +182,8 @@ die_if_kernel(char * str, struct pt_regs
 #ifdef CONFIG_SMP
 	printk("CPU %d ", hard_smp_processor_id());
 #endif
-	printk("%s(%d): %s %ld\n", current->comm, current->pid, str, err);
+	printk("%s(%d[#%u]): %s %ld\n", current->comm,
+		current->pid, current->xid, str, err);
 	dik_show_regs(regs, r9_15);
 	dik_show_trace((unsigned long *)(regs+1));
 	dik_show_code((unsigned int *)regs->pc);
diff -NurpP --minimal linux-2.6.18/arch/alpha/mm/init.c linux-2.6.18-vs2.1.1-rc37/arch/alpha/mm/init.c
--- linux-2.6.18/arch/alpha/mm/init.c	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/alpha/mm/init.c	2006-09-20 17:01:44 +0200
@@ -20,6 +20,7 @@
 #include <linux/init.h>
 #include <linux/bootmem.h> /* max_low_pfn */
 #include <linux/vmalloc.h>
+#include <linux/pagemap.h>
 
 #include <asm/system.h>
 #include <asm/uaccess.h>
diff -NurpP --minimal linux-2.6.18/arch/arm/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/arm/Kconfig
--- linux-2.6.18/arch/arm/Kconfig	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/arm/Kconfig	2006-09-20 17:01:44 +0200
@@ -907,6 +907,8 @@ source "arch/arm/oprofile/Kconfig"
 
 source "arch/arm/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/arm/kernel/calls.S linux-2.6.18-vs2.1.1-rc37/arch/arm/kernel/calls.S
--- linux-2.6.18/arch/arm/kernel/calls.S	2006-02-18 14:39:40 +0100
+++ linux-2.6.18-vs2.1.1-rc37/arch/arm/kernel/calls.S	2006-09-20 17:01:44 +0200
@@ -322,7 +322,7 @@
 /* 310 */	CALL(sys_request_key)
 		CALL(sys_keyctl)
 		CALL(ABI(sys_semtimedop, sys_oabi_semtimedop))
-/* vserver */	CALL(sys_ni_syscall)
+		CALL(sys_vserver)
 		CALL(sys_ioprio_set)
 /* 315 */	CALL(sys_ioprio_get)
 		CALL(sys_inotify_init)
diff -NurpP --minimal linux-2.6.18/arch/arm/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/arm/kernel/process.c
--- linux-2.6.18/arch/arm/kernel/process.c	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/arm/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -236,7 +236,8 @@ void __show_regs(struct pt_regs *regs)
 void show_regs(struct pt_regs * regs)
 {
 	printk("\n");
-	printk("Pid: %d, comm: %20s\n", current->pid, current->comm);
+	printk("Pid: %d[#%u], comm: %20s\n",
+		current->pid, current->xid, current->comm);
 	__show_regs(regs);
 	__backtrace();
 }
@@ -459,7 +460,8 @@ pid_t kernel_thread(int (*fn)(void *), v
 	regs.ARM_pc = (unsigned long)kernel_thread_helper;
 	regs.ARM_cpsr = SVC_MODE;
 
-	return do_fork(flags|CLONE_VM|CLONE_UNTRACED, 0, &regs, 0, NULL, NULL);
+	return do_fork(flags | CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD,
+		0, &regs, 0, NULL, NULL);
 }
 EXPORT_SYMBOL(kernel_thread);
 
diff -NurpP --minimal linux-2.6.18/arch/arm26/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/arm26/Kconfig
--- linux-2.6.18/arch/arm26/Kconfig	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/arm26/Kconfig	2006-09-20 17:01:44 +0200
@@ -234,6 +234,8 @@ source "drivers/usb/Kconfig"
 
 source "arch/arm26/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/arm26/kernel/calls.S linux-2.6.18-vs2.1.1-rc37/arch/arm26/kernel/calls.S
--- linux-2.6.18/arch/arm26/kernel/calls.S	2005-03-02 12:38:19 +0100
+++ linux-2.6.18-vs2.1.1-rc37/arch/arm26/kernel/calls.S	2006-09-20 17:01:44 +0200
@@ -257,6 +257,11 @@ __syscall_start:
 		.long	sys_lremovexattr
 		.long	sys_fremovexattr
 		.long	sys_tkill
+
+		.rept	313 - (. - __syscall_start) / 4
+			.long	sys_ni_syscall
+		.endr
+		.long	sys_vserver	/* 313 */
 __syscall_end:
 
 		.rept	NR_syscalls - (__syscall_end - __syscall_start) / 4
diff -NurpP --minimal linux-2.6.18/arch/arm26/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/arm26/kernel/process.c
--- linux-2.6.18/arch/arm26/kernel/process.c	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/arm26/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -365,7 +365,8 @@ pid_t kernel_thread(int (*fn)(void *), v
         regs.ARM_r3 = (unsigned long)do_exit;
         regs.ARM_pc = (unsigned long)kernel_thread_helper | MODE_SVC26;
 
-        return do_fork(flags|CLONE_VM|CLONE_UNTRACED, 0, &regs, 0, NULL, NULL);
+	return do_fork(flags | CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD,
+		0, &regs, 0, NULL, NULL);
 }
 EXPORT_SYMBOL(kernel_thread);
 
diff -NurpP --minimal linux-2.6.18/arch/arm26/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/arm26/kernel/traps.c
--- linux-2.6.18/arch/arm26/kernel/traps.c	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/arm26/kernel/traps.c	2006-09-20 17:01:44 +0200
@@ -185,8 +185,9 @@ NORET_TYPE void die(const char *str, str
 	printk("Internal error: %s: %x\n", str, err);
 	printk("CPU: %d\n", smp_processor_id());
 	show_regs(regs);
-	printk("Process %s (pid: %d, stack limit = 0x%p)\n",
-		current->comm, current->pid, end_of_stack(tsk));
+	printk("Process %s (pid: %d[#%u], stack limit = 0x%p)\n",
+		current->comm, current->pid,
+		current->xid, end_of_stack(tsk));
 
 	if (!user_mode(regs) || in_interrupt()) {
 		__dump_stack(tsk, (unsigned long)(regs + 1));
diff -NurpP --minimal linux-2.6.18/arch/cris/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/cris/Kconfig
--- linux-2.6.18/arch/cris/Kconfig	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/cris/Kconfig	2006-09-20 17:01:44 +0200
@@ -185,6 +185,8 @@ source "drivers/usb/Kconfig"
 
 source "arch/cris/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/cris/arch-v10/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/cris/arch-v10/kernel/process.c
--- linux-2.6.18/arch/cris/arch-v10/kernel/process.c	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/cris/arch-v10/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -103,7 +103,8 @@ int kernel_thread(int (*fn)(void *), voi
 	regs.dccr = 1 << I_DCCR_BITNR;
 
 	/* Ok, create the new process.. */
-        return do_fork(flags | CLONE_VM | CLONE_UNTRACED, 0, &regs, 0, NULL, NULL);
+	return do_fork(flags | CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD,
+		0, &regs, 0, NULL, NULL);
 }
 
 /* setup the child's kernel stack with a pt_regs and switch_stack on it.
diff -NurpP --minimal linux-2.6.18/arch/cris/arch-v32/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/cris/arch-v32/kernel/process.c
--- linux-2.6.18/arch/cris/arch-v32/kernel/process.c	2006-09-20 16:57:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/cris/arch-v32/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -120,7 +120,8 @@ kernel_thread(int (*fn)(void *), void * 
 	regs.ccs = 1 << (I_CCS_BITNR + CCS_SHIFT);
 
 	/* Create the new process. */
-        return do_fork(flags | CLONE_VM | CLONE_UNTRACED, 0, &regs, 0, NULL, NULL);
+	return do_fork(flags | CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD,
+		0, &regs, 0, NULL, NULL);
 }
 
 /*
diff -NurpP --minimal linux-2.6.18/arch/frv/kernel/kernel_thread.S linux-2.6.18-vs2.1.1-rc37/arch/frv/kernel/kernel_thread.S
--- linux-2.6.18/arch/frv/kernel/kernel_thread.S	2005-03-02 12:38:20 +0100
+++ linux-2.6.18-vs2.1.1-rc37/arch/frv/kernel/kernel_thread.S	2006-09-25 15:40:02 +0200
@@ -13,6 +13,8 @@
 #include <asm/unistd.h>
 
 #define CLONE_VM	0x00000100	/* set if VM shared between processes */
+#define CLONE_KTHREAD	0x10000000	/* kernel thread */
+#define CLONE_KT	(CLONE_VM | CLONE_KTHREAD)	/* kernel thread flags */
 #define	KERN_ERR	"<3>"
 
 	.section .rodata
@@ -37,7 +39,7 @@ kernel_thread:
 
 	# start by forking the current process, but with shared VM
 	setlos.p	#__NR_clone,gr7		; syscall number
-	ori		gr10,#CLONE_VM,gr8	; first syscall arg	[clone_flags]
+	ori		gr10,#CLONE_KT,gr8	; first syscall arg	[clone_flags]
 	sethi.p		#0xe4e4,gr9		; second syscall arg	[newsp]
 	setlo		#0xe4e4,gr9
 	setlos.p	#0,gr10			; third syscall arg	[parent_tidptr]
diff -NurpP --minimal linux-2.6.18/arch/h8300/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/h8300/Kconfig
--- linux-2.6.18/arch/h8300/Kconfig	2006-06-18 04:51:49 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/h8300/Kconfig	2006-09-20 17:01:44 +0200
@@ -199,6 +199,8 @@ source "fs/Kconfig"
 
 source "arch/h8300/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/h8300/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/h8300/kernel/process.c
--- linux-2.6.18/arch/h8300/kernel/process.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/h8300/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -134,7 +134,7 @@ int kernel_thread(int (*fn)(void *), voi
 
 	fs = get_fs();
 	set_fs (KERNEL_DS);
-	clone_arg = flags | CLONE_VM;
+	clone_arg = flags | CLONE_VM | CLONE_KTHREAD;
 	__asm__("mov.l sp,er3\n\t"
 		"sub.l er2,er2\n\t"
 		"mov.l %2,er1\n\t"
diff -NurpP --minimal linux-2.6.18/arch/i386/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/i386/Kconfig
--- linux-2.6.18/arch/i386/Kconfig	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/i386/Kconfig	2006-09-20 17:01:44 +0200
@@ -1142,6 +1142,8 @@ endmenu
 
 source "arch/i386/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/i386/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/i386/kernel/process.c
--- linux-2.6.18/arch/i386/kernel/process.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/i386/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -289,8 +289,10 @@ void show_regs(struct pt_regs * regs)
 	unsigned long cr0 = 0L, cr2 = 0L, cr3 = 0L, cr4 = 0L;
 
 	printk("\n");
-	printk("Pid: %d, comm: %20s\n", current->pid, current->comm);
-	printk("EIP: %04x:[<%08lx>] CPU: %d\n",0xffff & regs->xcs,regs->eip, smp_processor_id());
+	printk("Pid: %d[#%u], comm: %20s\n",
+		current->pid, current->xid, current->comm);
+	printk("EIP: %04x:[<%08lx>] CPU: %d\n",
+		0xffff & regs->xcs,regs->eip, smp_processor_id());
 	print_symbol("EIP is at %s\n", regs->eip);
 
 	if (user_mode_vm(regs))
@@ -350,7 +352,8 @@ int kernel_thread(int (*fn)(void *), voi
 	regs.eflags = X86_EFLAGS_IF | X86_EFLAGS_SF | X86_EFLAGS_PF | 0x2;
 
 	/* Ok, create the new process.. */
-	return do_fork(flags | CLONE_VM | CLONE_UNTRACED, 0, &regs, 0, NULL, NULL);
+	return do_fork(flags | CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD,
+		0, &regs, 0, NULL, NULL);
 }
 EXPORT_SYMBOL(kernel_thread);
 
diff -NurpP --minimal linux-2.6.18/arch/i386/kernel/sys_i386.c linux-2.6.18-vs2.1.1-rc37/arch/i386/kernel/sys_i386.c
--- linux-2.6.18/arch/i386/kernel/sys_i386.c	2006-06-18 04:51:53 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/i386/kernel/sys_i386.c	2006-09-20 17:01:44 +0200
@@ -19,6 +19,7 @@
 #include <linux/mman.h>
 #include <linux/file.h>
 #include <linux/utsname.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
@@ -210,7 +211,7 @@ asmlinkage int sys_uname(struct old_utsn
 	if (!name)
 		return -EFAULT;
 	down_read(&uts_sem);
-	err=copy_to_user(name, &system_utsname, sizeof (*name));
+	err=copy_to_user(name, vx_new_utsname(), sizeof (*name));
 	up_read(&uts_sem);
 	return err?-EFAULT:0;
 }
@@ -218,6 +219,7 @@ asmlinkage int sys_uname(struct old_utsn
 asmlinkage int sys_olduname(struct oldold_utsname __user * name)
 {
 	int error;
+	struct new_utsname *ptr;
 
 	if (!name)
 		return -EFAULT;
@@ -226,15 +228,16 @@ asmlinkage int sys_olduname(struct oldol
   
   	down_read(&uts_sem);
 	
-	error = __copy_to_user(&name->sysname,&system_utsname.sysname,__OLD_UTS_LEN);
+	ptr = vx_new_utsname();
+	error = __copy_to_user(&name->sysname,ptr->sysname,__OLD_UTS_LEN);
 	error |= __put_user(0,name->sysname+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->nodename,&system_utsname.nodename,__OLD_UTS_LEN);
+	error |= __copy_to_user(&name->nodename,ptr->nodename,__OLD_UTS_LEN);
 	error |= __put_user(0,name->nodename+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->release,&system_utsname.release,__OLD_UTS_LEN);
+	error |= __copy_to_user(&name->release,ptr->release,__OLD_UTS_LEN);
 	error |= __put_user(0,name->release+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->version,&system_utsname.version,__OLD_UTS_LEN);
+	error |= __copy_to_user(&name->version,ptr->version,__OLD_UTS_LEN);
 	error |= __put_user(0,name->version+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->machine,&system_utsname.machine,__OLD_UTS_LEN);
+	error |= __copy_to_user(&name->machine,ptr->machine,__OLD_UTS_LEN);
 	error |= __put_user(0,name->machine+__OLD_UTS_LEN);
 	
 	up_read(&uts_sem);
diff -NurpP --minimal linux-2.6.18/arch/i386/kernel/syscall_table.S linux-2.6.18-vs2.1.1-rc37/arch/i386/kernel/syscall_table.S
--- linux-2.6.18/arch/i386/kernel/syscall_table.S	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/i386/kernel/syscall_table.S	2006-09-20 17:01:44 +0200
@@ -272,7 +272,7 @@ ENTRY(sys_call_table)
 	.long sys_tgkill	/* 270 */
 	.long sys_utimes
  	.long sys_fadvise64_64
-	.long sys_ni_syscall	/* sys_vserver */
+	.long sys_vserver
 	.long sys_mbind
 	.long sys_get_mempolicy
 	.long sys_set_mempolicy
diff -NurpP --minimal linux-2.6.18/arch/i386/kernel/sysenter.c linux-2.6.18-vs2.1.1-rc37/arch/i386/kernel/sysenter.c
--- linux-2.6.18/arch/i386/kernel/sysenter.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/i386/kernel/sysenter.c	2006-09-20 21:46:26 +0200
@@ -17,6 +17,7 @@
 #include <linux/elf.h>
 #include <linux/mm.h>
 #include <linux/module.h>
+#include <linux/vs_memory.h>
 
 #include <asm/cpufeature.h>
 #include <asm/msr.h>
@@ -156,7 +157,7 @@ int arch_setup_additional_pages(struct l
 	current->mm->context.vdso = (void *)addr;
 	current_thread_info()->sysenter_return =
 				    (void *)VDSO_SYM(&SYSENTER_RETURN);
-	mm->total_vm++;
+	vx_vmpages_inc(mm);
 up_fail:
 	up_write(&mm->mmap_sem);
 	return ret;
diff -NurpP --minimal linux-2.6.18/arch/i386/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/i386/kernel/traps.c
--- linux-2.6.18/arch/i386/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/i386/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -53,6 +53,8 @@
 #include <asm/kdebug.h>
 
 #include <linux/module.h>
+#include <linux/vserver/debug.h>
+#include <linux/vserver/history.h>
 
 #include "mach_traps.h"
 
@@ -304,8 +306,8 @@ void show_registers(struct pt_regs *regs
 		regs->esi, regs->edi, regs->ebp, esp);
 	printk(KERN_EMERG "ds: %04x   es: %04x   ss: %04x\n",
 		regs->xds & 0xffff, regs->xes & 0xffff, ss);
-	printk(KERN_EMERG "Process %.*s (pid: %d, ti=%p task=%p task.ti=%p)",
-		TASK_COMM_LEN, current->comm, current->pid,
+	printk(KERN_EMERG "Process %.*s (pid: %d[#%u], ti=%p task=%p task.ti=%p)",
+		TASK_COMM_LEN, current->comm, current->pid, current->xid,
 		current_thread_info(), current, current->thread_info);
 	/*
 	 * When in-kernel, we also print out the stack and code at the
@@ -388,6 +390,8 @@ void die(const char * str, struct pt_reg
 
 	oops_enter();
 
+	vxh_throw_oops();
+
 	if (die.lock_owner != raw_smp_processor_id()) {
 		console_verbose();
 		spin_lock_irqsave(&die.lock, flags);
@@ -424,9 +428,9 @@ void die(const char * str, struct pt_reg
 		if (nl)
 			printk("\n");
 		if (notify_die(DIE_OOPS, str, regs, err,
-					current->thread.trap_no, SIGSEGV) !=
-				NOTIFY_STOP) {
+			current->thread.trap_no, SIGSEGV) != NOTIFY_STOP) {
 			show_registers(regs);
+			vxh_dump_history();
 			/* Executive summary in case the oops scrolled away */
 			esp = (unsigned long) (&regs->esp);
 			savesegment(ss, ss);
diff -NurpP --minimal linux-2.6.18/arch/ia64/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/ia64/Kconfig
--- linux-2.6.18/arch/ia64/Kconfig	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ia64/Kconfig	2006-09-20 17:01:44 +0200
@@ -525,6 +525,8 @@ endmenu
 
 source "arch/ia64/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/ia64/ia32/binfmt_elf32.c linux-2.6.18-vs2.1.1-rc37/arch/ia64/ia32/binfmt_elf32.c
--- linux-2.6.18/arch/ia64/ia32/binfmt_elf32.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ia64/ia32/binfmt_elf32.c	2006-09-20 17:01:44 +0200
@@ -238,7 +238,8 @@ ia32_setup_arg_pages (struct linux_binpr
 			kmem_cache_free(vm_area_cachep, mpnt);
 			return ret;
 		}
-		current->mm->stack_vm = current->mm->total_vm = vma_pages(mpnt);
+		vx_vmpages_sub(current->mm, current->mm->total_vm - vma_pages(mpnt));
+		current->mm->stack_vm = current->mm->total_vm;
 	}
 
 	for (i = 0 ; i < MAX_ARG_PAGES ; i++) {
diff -NurpP --minimal linux-2.6.18/arch/ia64/ia32/ia32_entry.S linux-2.6.18-vs2.1.1-rc37/arch/ia64/ia32/ia32_entry.S
--- linux-2.6.18/arch/ia64/ia32/ia32_entry.S	2006-06-18 04:51:55 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ia64/ia32/ia32_entry.S	2006-09-20 17:01:44 +0200
@@ -483,7 +483,7 @@ ia32_syscall_table:
  	data8 sys_tgkill	/* 270 */
  	data8 compat_sys_utimes
  	data8 sys32_fadvise64_64
- 	data8 sys_ni_syscall
+	data8 sys32_vserver
   	data8 sys_ni_syscall
  	data8 sys_ni_syscall	/* 275 */
   	data8 sys_ni_syscall
diff -NurpP --minimal linux-2.6.18/arch/ia64/ia32/sys_ia32.c linux-2.6.18-vs2.1.1-rc37/arch/ia64/ia32/sys_ia32.c
--- linux-2.6.18/arch/ia64/ia32/sys_ia32.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ia64/ia32/sys_ia32.c	2006-10-06 23:10:42 +0200
@@ -1177,7 +1177,7 @@ sys32_gettimeofday (struct compat_timeva
 {
 	if (tv) {
 		struct timeval ktv;
-		do_gettimeofday(&ktv);
+		vx_gettimeofday(&ktv);
 		if (put_tv32(tv, &ktv))
 			return -EFAULT;
 	}
diff -NurpP --minimal linux-2.6.18/arch/ia64/kernel/asm-offsets.c linux-2.6.18-vs2.1.1-rc37/arch/ia64/kernel/asm-offsets.c
--- linux-2.6.18/arch/ia64/kernel/asm-offsets.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ia64/kernel/asm-offsets.c	2006-09-25 15:40:02 +0200
@@ -191,6 +191,7 @@ void foo(void)
     /* for assembly files which can't include sched.h: */
 	DEFINE(IA64_CLONE_VFORK, CLONE_VFORK);
 	DEFINE(IA64_CLONE_VM, CLONE_VM);
+	DEFINE(IA64_CLONE_KTHREAD, CLONE_KTHREAD);
 
 	BLANK();
 	DEFINE(IA64_CPUINFO_NSEC_PER_CYC_OFFSET,
diff -NurpP --minimal linux-2.6.18/arch/ia64/kernel/entry.S linux-2.6.18-vs2.1.1-rc37/arch/ia64/kernel/entry.S
--- linux-2.6.18/arch/ia64/kernel/entry.S	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ia64/kernel/entry.S	2006-09-20 17:01:44 +0200
@@ -1576,7 +1576,7 @@ sys_call_table:
 	data8 sys_mq_notify
 	data8 sys_mq_getsetattr
 	data8 sys_ni_syscall			// reserved for kexec_load
-	data8 sys_ni_syscall			// reserved for vserver
+	data8 sys_vserver
 	data8 sys_waitid			// 1270
 	data8 sys_add_key
 	data8 sys_request_key
diff -NurpP --minimal linux-2.6.18/arch/ia64/kernel/perfmon.c linux-2.6.18-vs2.1.1-rc37/arch/ia64/kernel/perfmon.c
--- linux-2.6.18/arch/ia64/kernel/perfmon.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ia64/kernel/perfmon.c	2006-10-07 04:29:47 +0200
@@ -40,6 +40,7 @@
 #include <linux/capability.h>
 #include <linux/rcupdate.h>
 #include <linux/completion.h>
+#include <linux/vs_memory.h>
 
 #include <asm/errno.h>
 #include <asm/intrinsics.h>
@@ -2354,7 +2355,7 @@ pfm_smpl_buffer_alloc(struct task_struct
 	 */
 	insert_vm_struct(mm, vma);
 
-	mm->total_vm  += size >> PAGE_SHIFT;
+	vx_vmpages_add(mm, size >> PAGE_SHIFT);
 	vm_stat_account(vma->vm_mm, vma->vm_flags, vma->vm_file,
 							vma_pages(vma));
 	up_write(&task->mm->mmap_sem);
diff -NurpP --minimal linux-2.6.18/arch/ia64/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/ia64/kernel/process.c
--- linux-2.6.18/arch/ia64/kernel/process.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ia64/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -107,7 +107,8 @@ show_regs (struct pt_regs *regs)
 	unsigned long ip = regs->cr_iip + ia64_psr(regs)->ri;
 
 	print_modules();
-	printk("\nPid: %d, CPU %d, comm: %20s\n", current->pid, smp_processor_id(), current->comm);
+	printk("\nPid: %d[#%u], CPU %d, comm: %20s\n",
+		current->pid, current->xid, smp_processor_id(), current->comm);
 	printk("psr : %016lx ifs : %016lx ip  : [<%016lx>]    %s\n",
 	       regs->cr_ipsr, regs->cr_ifs, ip, print_tainted());
 	print_symbol("ip is at %s\n", ip);
@@ -690,7 +691,8 @@ kernel_thread (int (*fn)(void *), void *
 	regs.sw.ar_fpsr = regs.pt.ar_fpsr = ia64_getreg(_IA64_REG_AR_FPSR);
 	regs.sw.ar_bspstore = (unsigned long) current + IA64_RBS_OFFSET;
 	regs.sw.pr = (1 << PRED_KERNEL_STACK);
-	return do_fork(flags | CLONE_VM | CLONE_UNTRACED, 0, &regs.pt, 0, NULL, NULL);
+	return do_fork(flags | CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD,
+		0, &regs.pt, 0, NULL, NULL);
 }
 EXPORT_SYMBOL(kernel_thread);
 
diff -NurpP --minimal linux-2.6.18/arch/ia64/kernel/ptrace.c linux-2.6.18-vs2.1.1-rc37/arch/ia64/kernel/ptrace.c
--- linux-2.6.18/arch/ia64/kernel/ptrace.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ia64/kernel/ptrace.c	2006-10-07 04:29:47 +0200
@@ -1442,6 +1442,9 @@ sys_ptrace (long request, pid_t pid, uns
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH_P|VX_IDENT))
+		goto out_tsk;
+
 	ret = -EPERM;
 	if (pid == 1)		/* no messing around with init! */
 		goto out_tsk;
diff -NurpP --minimal linux-2.6.18/arch/ia64/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/ia64/kernel/traps.c
--- linux-2.6.18/arch/ia64/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ia64/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -106,8 +106,9 @@ die (const char *str, struct pt_regs *re
 	put_cpu();
 
 	if (++die.lock_owner_depth < 3) {
-		printk("%s[%d]: %s %ld [%d]\n",
-			current->comm, current->pid, str, err, ++die_counter);
+		printk("%s[%d[#%u]]: %s %ld [%d]\n",
+			current->comm, current->pid, current->xid,
+			str, err, ++die_counter);
 		(void) notify_die(DIE_OOPS, (char *)str, regs, err, 255, SIGSEGV);
 		show_regs(regs);
   	} else
@@ -331,8 +332,9 @@ handle_fpu_swa (int fp_fault, struct pt_
 		last_time = jiffies;
 		++fpu_swa_count;
 		printk(KERN_WARNING
-		       "%s(%d): floating-point assist fault at ip %016lx, isr %016lx\n",
-		       current->comm, current->pid, regs->cr_iip + ia64_psr(regs)->ri, isr);
+		       "%s(%d[#%u]): floating-point assist fault at ip %016lx, isr %016lx\n",
+		       current->comm, current->pid, current->xid,
+		       regs->cr_iip + ia64_psr(regs)->ri, isr);
 	}
 
 	exception = fp_emulate(fp_fault, bundle, &regs->cr_ipsr, &regs->ar_fpsr, &isr, &regs->pr,
diff -NurpP --minimal linux-2.6.18/arch/ia64/mm/fault.c linux-2.6.18-vs2.1.1-rc37/arch/ia64/mm/fault.c
--- linux-2.6.18/arch/ia64/mm/fault.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ia64/mm/fault.c	2006-09-20 17:01:44 +0200
@@ -10,6 +10,7 @@
 #include <linux/smp_lock.h>
 #include <linux/interrupt.h>
 #include <linux/kprobes.h>
+#include <linux/vs_memory.h>
 
 #include <asm/pgtable.h>
 #include <asm/processor.h>
diff -NurpP --minimal linux-2.6.18/arch/ia64/sn/kernel/xpc_main.c linux-2.6.18-vs2.1.1-rc37/arch/ia64/sn/kernel/xpc_main.c
--- linux-2.6.18/arch/ia64/sn/kernel/xpc_main.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ia64/sn/kernel/xpc_main.c	2006-09-20 17:01:44 +0200
@@ -108,6 +108,7 @@ static ctl_table xpc_sys_xpc_hb_dir[] = 
 		0644,
 		NULL,
 		&proc_dointvec_minmax,
+		NULL,
 		&sysctl_intvec,
 		NULL,
 		&xpc_hb_min_interval,
@@ -121,6 +122,7 @@ static ctl_table xpc_sys_xpc_hb_dir[] = 
 		0644,
 		NULL,
 		&proc_dointvec_minmax,
+		NULL,
 		&sysctl_intvec,
 		NULL,
 		&xpc_hb_check_min_interval,
@@ -145,6 +147,7 @@ static ctl_table xpc_sys_xpc_dir[] = {
 		0644,
 		NULL,
 		&proc_dointvec_minmax,
+		NULL,
 		&sysctl_intvec,
 		NULL,
 		&xpc_disengage_request_min_timelimit,
diff -NurpP --minimal linux-2.6.18/arch/m32r/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/m32r/kernel/process.c
--- linux-2.6.18/arch/m32r/kernel/process.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/m32r/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -211,8 +211,8 @@ int kernel_thread(int (*fn)(void *), voi
 	regs.psw = M32R_PSW_BIE;
 
 	/* Ok, create the new process. */
-	return do_fork(flags | CLONE_VM | CLONE_UNTRACED, 0, &regs, 0, NULL,
-		NULL);
+	return do_fork(flags | CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD,
+		0, &regs, 0, NULL, NULL);
 }
 
 /*
diff -NurpP --minimal linux-2.6.18/arch/m32r/kernel/sys_m32r.c linux-2.6.18-vs2.1.1-rc37/arch/m32r/kernel/sys_m32r.c
--- linux-2.6.18/arch/m32r/kernel/sys_m32r.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/m32r/kernel/sys_m32r.c	2006-09-20 17:01:44 +0200
@@ -20,6 +20,7 @@
 #include <linux/mman.h>
 #include <linux/file.h>
 #include <linux/utsname.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/cachectl.h>
@@ -205,7 +206,7 @@ asmlinkage int sys_uname(struct old_utsn
 	if (!name)
 		return -EFAULT;
 	down_read(&uts_sem);
-	err=copy_to_user(name, &system_utsname, sizeof (*name));
+	err=copy_to_user(name, vx_new_utsname(), sizeof (*name));
 	up_read(&uts_sem);
 	return err?-EFAULT:0;
 }
